#include "ell/SC_ListingCompr.hh"

namespace ell {
	
	SC_ListingCompr::SC_ListingCompr()
	 : SC_Counting(), stateList() 
	{
	}
	
	SC_ListingCompr::~SC_ListingCompr()
	{
	}

	  // This function is used to track all added intermediate States.
	  // @param s the added State
	void 
	SC_ListingCompr::add(const State& s) {
		  // call handler of super class
		SC_Counting::add(s);
		  // store compressed string representation of s
		stateList.push_back(s.compress());
	}
	
	///////////  LIST HANDLING  ////////////////////////

	  // Returns a list of all added States.
	  // @return the State list
	const SC_ListingCompr::List&
	SC_ListingCompr::getList() const {
		return stateList;
	}

} // namespace ell	
