

#include <ell/LT_MinimaSet.hh>

#include "DummyState.hh"

using namespace ell;

int main(int argc, char** argv) {
	
	
	std::cout	<<"========== BEGIN OF TEST ==================\n"
				<<" test class : LT_MinimaSet\n"
				<<"===========================================" <<std::endl;


	std::cout	<< "=> creating LT_MinimaSet ms" << std::endl;
	LT_MinimaSet ms;
	
	  // vector of my dummy states
	std::vector<DummyState> s;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_1", 10));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_2", 9));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_3", 12));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_4", 3));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_0", 9));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	
	std::cout	<< "=> adding states to the set" <<std::endl;
	for (size_t i=0; i<s.size(); i++) {
		std::cout <<" ."; std::cout.flush();
		ms.addMin(&s[i]);
	}
	std::cout	<< std::endl;
	std::cout	<< "=> ms.getMinCount() = " <<ms.getMinCount() <<std::endl;
	std::cout	<< "=> ms.getMinIndex("<<s[2].toString()<<") = " <<ms.getMinIndex(&s[2]) <<std::endl;
	std::cout	<< "=> ms.getMin("<<ms.getMinIndex(&s[2])<<") = " <<ms.getMin(ms.getMinIndex(&s[2]))->toString() <<std::endl;
	std::cout	<< "=> ms.getMFEState()->toString() = " <<ms.getMFEState()->toString() <<std::endl;
	
	std::cout	<< "=> ms.write(std::cout, Dummy)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	ms.write(std::cout, "Dummy");
	std::cout	<< "-----------------------------------------" <<std::endl;
	
	std::cout	<< "=> ms.isSorted() = " <<(ms.isSorted()?"true":"false") <<std::endl;
	std::cout	<< "=> ms.sort()" <<std::endl;
	ms.sort();
	std::cout	<< "=> ms.isSorted() = " <<(ms.isSorted()?"true":"false") <<std::endl;
	std::cout	<< "=> ms.getMFEState()->toString() = " <<ms.getMFEState()->toString() <<std::endl;
	std::cout	<< "=> ms.write(std::cout, Dummy)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	ms.write(std::cout, "Dummy");
	std::cout	<< "-----------------------------------------" <<std::endl;
	
	LT_MinimaSet ms2;
	std::cout	<< "=> creating LT_MinimaSet ms2" << std::endl;
	std::stringstream ss;
	ms.write(ss,"Dummy");
	std::cout	<< "=> ms2.read( ms.write )" <<std::endl;
	std::pair<int,std::string> res = ms2.read(ss,&s[0],"Dummy");
	std::cout	<< "   -> result = ( " <<res.first <<", '" <<res.second <<"' )" <<std::endl;
	std::cout	<< "=> ms2.write(std::cout, Dummy)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	ms2.write(std::cout, "Dummy");
	std::cout	<< "-----------------------------------------" <<std::endl;
	std::cout	<< "=> ms2.isSorted() = " <<(ms2.isSorted()?"true":"false") <<std::endl;
	
	std::cout	<< "=> ms.getRMSD(ms2) = " <<ms.getRMSD(&ms2) <<std::endl;
	
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_X", 1));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> ms.getMinIndex("<<s.rbegin()->toString()<<") == INVALID_INDEX ? = " <<(ms.getMinIndex(&(*s.rbegin()))==LandscapeTopology::INVALID_INDEX?"true":"false") <<std::endl;

	std::cout	<< "=> ms2.clear() " <<std::endl;
	ms2.clear();
	std::cout	<< "=> ms2.getMinCount() = " <<ms2.getMinCount() <<std::endl;
	

	std::cout	<<"============= END OF TEST =================\n" <<std::endl;
	
	return 0;
}
